<?php
/**
*
* @package - AM Attendance Mod
* @version $Id: acp_am_presets.php 92 2011-01-14 16:20:42Z wired076 $
* @copyright (c) wired076 ( http://www.itconstruct.com.au/ ) 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_am_presets
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/info_am_presets');

		// Set up general vars
		$action = request_var('action', '');
		$action = (isset($_POST['add'])) ? 'add' : ((isset($_POST['save'])) ? 'save' : $action);
		$am_preset_id = request_var('id', 0);

		$s_hidden_fields = '';
		$am_preset_info = array();

		$this->tpl_name = 'acp_am_presets';
		$this->page_title = 'ACP_AM_PRESETS';

		$form_name = 'acp_am_presets';
		add_form_key($form_name);

		switch ($action)
		{
			case 'edit':

				if (!$am_preset_id)
				{
					trigger_error($user->lang['NO_WORD'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				$sql = "SELECT *
					FROM " . AM_PRESETS_TABLE . "
					WHERE am_preset_id = " . (int) $am_preset_id;
				$result = $db->sql_query($sql);
				$am_preset_info = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$s_hidden_fields .= '<input type="hidden" name="id" value="' . $am_preset_id . '" />';

			case 'add':

				$s_am_layout_options = '';

				if (sizeof($am_preset_info) > 0)
				{
					$am_preset_option_text 		= array();
					$am_preset_option_max 		= array();
					$am_preset_option_color 	= array();

					$am_preset_option_text	= explode("\\n", $am_preset_info['am_option_text']);
					$am_preset_option_max	= explode("\\n", $am_preset_info['am_option_max']);
					$am_preset_option_color	= explode("\\n", $am_preset_info['am_option_color']);

					$count = 0;

					foreach ($am_preset_option_text as $key => $option)
					{
						if (!empty($option))
						{
							$am_preset_option_text[$key]	= '"'.$option.'"';
							$am_preset_option_max[$key]		= '"'.$am_preset_option_max[$count].'"';
							$am_preset_option_color[$key]	= '"'.$am_preset_option_color[$count].'"';
						}
						$count++;
					}
				}

				for ($i=0; $i<2; $i++)
				{
					$am_layout_option_lang		= $user->lang['AM_LAYOUT_'.$i];
					$am_layout_option_checked	= ((isset($am_preset_info['am_layout']) && ($am_preset_info['am_layout'] == $i)) ? 'selected="selected"' : '');
					$s_am_layout_options		.= '<option value="' . $i . '"' . $am_layout_option_checked . '>' . $am_layout_option_lang . '</option>';
				}

				$template->assign_vars(array(
					'S_EDIT_PRESET'		=> true,
					'U_ACTION'			=> $this->u_action,
					'U_BACK'			=> $this->u_action,

					'AM_PRESET_NAME'		=> (isset($am_preset_info['am_preset_name'])) ? $am_preset_info['am_preset_name'] : '',

					'AM_OPTIONS'			=> (isset($am_preset_option_text)) ? implode(",", $am_preset_option_text) : '',
					'AM_OPTIONS_MAX'		=> (isset($am_preset_option_max)) ? implode(",", $am_preset_option_max) : '',
					'AM_OPTIONS_COLOR'		=> (isset($am_preset_option_color)) ? implode(",", $am_preset_option_color) : '',

					'AM_PRESET_LENGTH'		=> (isset($am_preset_info['am_length'])) ? $am_preset_info['am_length'] : 0,
					'AM_PRESET_REG_CHANGE'	=> ((isset($am_preset_info['am_reg_change']) && $am_preset_info['am_reg_change'] > 0 )) ? 'checked="checked"' : '',
					'AM_PRESET_CONFIRMABLE'	=> ((isset($am_preset_info['am_confirmable']) && $am_preset_info['am_confirmable'] > 0 )) ? 'checked="checked"' : '',
					'AM_PRESET_VISIBLE'		=> ((isset($am_preset_info['am_visible']) && $am_preset_info['am_visible'] > 0 )) ? 'checked="checked"' : '',

					'S_AM_PRESET_LAYOUT_OPTIONS'	=> $s_am_layout_options,
					'S_HIDDEN_FIELDS'				=> $s_hidden_fields)
				);

				return;

			break;

			case 'save':

				$am_preset_option_text_ary 	= array();
				$am_preset_option_max_ary 	= array();
				$am_preset_option_color_ary	= array();
				$am_preset_option_text	= '';
				$am_preset_option_max	= '';
				$am_preset_option_color	= '';

				if (!check_form_key($form_name))
				{
					trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
				}

				$am_preset_name				= utf8_normalize_nfc(request_var('am_preset_name', '', true));
				$am_preset_layout			= request_var('am_preset_layout', 0);
				$am_preset_length			= request_var('am_preset_length', 0, true);
				$am_preset_visible			= (isset($_POST['am_preset_visible'])) ? 1 : 0;
				$am_preset_confirmable		= (isset($_POST['am_preset_confirmable'])) ? 1 : 0;
				$am_preset_reg_change		= (isset($_POST['am_preset_reg_change'])) ? 1 : 0;
				$am_preset_option_text_ary	= utf8_normalize_nfc(request_var('am_option_text', array(''), true));
				$am_preset_option_max_ary	= utf8_normalize_nfc(request_var('am_option_max', array(''), true));
				$am_preset_option_color_ary	= utf8_normalize_nfc(request_var('am_option_color', array(''), true));

				for ($i = 0, $size = sizeof($am_preset_option_text_ary); $i < $size; $i++)
				{
					$delimiter = (($size - 1 == $i) ? '' : '\n');
					if (!empty($am_preset_option_text_ary[$i]))
					{
						$am_preset_option_text	.= (string) $am_preset_option_text_ary[$i].$delimiter;
						$am_preset_option_max 	.= (string) $am_preset_option_max_ary[$i].$delimiter;
						$am_preset_option_color .= (string) $am_preset_option_color_ary[$i].$delimiter;
					}
				}
				unset($am_preset_option_text_ary, $am_preset_option_max_ary, $am_preset_option_color_ary);

				if (!$am_preset_name)
				{
					trigger_error($user->lang['AM_ENTER_NAME'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				$sql_ary = array(
					'am_preset_name'	=> $am_preset_name,
					'am_length'			=> $am_preset_length,
					'am_visible'		=> $am_preset_visible,
					'am_confirmable'	=> $am_preset_confirmable,
					'am_reg_change'		=> $am_preset_reg_change,
					'am_layout'			=> $am_preset_layout,
					'am_option_text'	=> $am_preset_option_text,
					'am_option_max'		=> $am_preset_option_max,
					'am_option_color'	=> $am_preset_option_color
				);

				if ($am_preset_id)
				{
					$db->sql_query('UPDATE ' . AM_PRESETS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE am_preset_id = ' . (int) $am_preset_id);
				}
				else
				{
					$sql = 'SELECT MAX(am_preset_order) as max_order
						FROM ' . AM_PRESETS_TABLE;
					$result = $db->sql_query($sql);
					$max_order = (int) $db->sql_fetchfield('max_order');
					$db->sql_freeresult($result);

					$sql_ary['am_preset_order'] = $max_order + 1;
					$db->sql_query('INSERT INTO ' . AM_PRESETS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
				}

				$log_action = ($am_preset_id) ? 'AM_LOG_PRESET_EDIT' : 'AM_LOG_PRESET_ADD';
				add_log('admin', $log_action, $am_preset_name);

				$message = ($am_preset_id) ? $user->lang['AM_PRESET_UPDATED'] : $user->lang['AM_PRESET_ADDED'];
				trigger_error($message . adm_back_link($this->u_action));

			break;

			case 'delete':

				if (!$am_preset_id)
				{
					trigger_error($user->lang['NO_PRESET'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				if (confirm_box(true))
				{
					$sql = 'SELECT am_preset_name
						FROM ' . AM_PRESETS_TABLE . "
						WHERE am_preset_id = " . (int) $am_preset_id;
					$result = $db->sql_query($sql);
					$deleted_preset = $db->sql_fetchfield('am_preset_name');
					$db->sql_freeresult($result);

					$sql = 'DELETE FROM ' . AM_PRESETS_TABLE . "
						WHERE am_preset_id = " . (int) $am_preset_id;
					$db->sql_query($sql);

					add_log('admin', 'AM_LOG_PRESET_DELETE', $deleted_preset);

					trigger_error($user->lang['AM_PRESET_REMOVED'] . adm_back_link($this->u_action));
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
						'i'			=> $id,
						'mode'		=> $mode,
						'id'		=> $am_preset_id,
						'action'	=> 'delete',
					)));
				}

			break;

			case 'move_up':
			case 'move_down':

				$table = AM_PRESETS_TABLE;

				// Get current order id...
				$sql = "SELECT am_preset_order as current_order
					FROM $table
					WHERE am_preset_id = " . (int) $am_preset_id;
				$result = $db->sql_query($sql);
				$current_order = (int) $db->sql_fetchfield('current_order');
				$db->sql_freeresult($result);

				if ($current_order == 0 && $action == 'move_up')
				{
					break;
				}

				// on move_down, switch position with next order_id...
				// on move_up, switch position with previous order_id...
				$switch_order_id = ($action == 'move_down') ? $current_order + 1 : $current_order - 1;

				//
				$sql = "UPDATE $table
					SET am_preset_order = $current_order
					WHERE am_preset_order = $switch_order_id
						AND am_preset_id <>" . (int) $am_preset_id;
				$db->sql_query($sql);

				// Only update the other entry too if the previous entry got updated
				if ($db->sql_affectedrows())
				{
					$sql = "UPDATE $table
						SET am_preset_order = $switch_order_id
						WHERE am_preset_order = $current_order
							AND am_preset_id = " . (int) $am_preset_id;
					$db->sql_query($sql);
				}

				$cache->destroy('sql', $table);

			break;
		}


		$template->assign_vars(array(
			'U_ACTION'			=> $this->u_action,
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields)
		);

		$sql = 'SELECT *
			FROM ' . AM_PRESETS_TABLE . '
			ORDER BY am_preset_order ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$am_preset_options			= '';
			$am_preset_option_text 		= array();
			$am_preset_option_max 		= array();
			$am_preset_option_color 	= array();

			$am_preset_option_text	= explode("\\n", $row['am_option_text']);
			$am_preset_option_max	= explode("\\n", $row['am_option_max']);
			$am_preset_option_color	= explode("\\n", $row['am_option_color']);

			for ($i=0, $size=sizeof($am_preset_option_text); $i<$size; $i++)
			{
				$am_preset_max = ($am_preset_option_max[$i] ? (($am_preset_option_max[$i] == 1) ? sprintf($user->lang['AM_SLOT'], $am_preset_option_max[$i]) : sprintf($user->lang['AM_SLOTS'], $am_preset_option_max[$i]) ) : '' );
				$am_preset_options .= '<input value="'.$am_preset_option_text[$i].'" class="button2 " style="color: '.$am_preset_option_color[$i].';"/> '.$am_preset_max.'<br />';
			}

			$am_preset_settings = '';
			$am_preset_layout = $row['am_layout'];

			$am_preset_settings .= (($row['am_length'] > 0) ? sprintf($user->lang['AM_PRESET_LENGTH_TEXT']."<br /><br />", $row['am_length']) : $user->lang['AM_PRESET_UNLIMITED_LENGTH_TEXT']."<br /><br />" );
			$am_preset_settings .= $user->lang['AM_LAYOUT'].": ".$user->lang['AM_LAYOUT_'.$am_preset_layout]."<br />";
			$am_preset_settings .= (($row['am_reg_change'] > 0) ? $user->lang['AM_REG_CHANGE'].": <strong>".$user->lang['YES']."</strong><br />" : $user->lang['AM_REG_CHANGE'].": <strong>".$user->lang['NO']."</strong><br />" );
			$am_preset_settings .= (($row['am_confirmable'] > 0) ? $user->lang['AM_CONFIRMABLE'].": <strong>".$user->lang['YES']."</strong><br />" : $user->lang['AM_CONFIRMABLE'].": <strong>".$user->lang['NO']."</strong><br />" );
			$am_preset_settings .= (($row['am_visible'] > 0) ? $user->lang['AM_VISIBLE'].": <strong>".$user->lang['YES']."</strong><br />" : $user->lang['AM_VISIBLE'].": <strong>".$user->lang['NO']."</strong><br />" );

			$template->assign_block_vars('presets', array(
				'AM_PRESET_NAME'			=> $row['am_preset_name'],
				'AM_PRESET_OPTIONS'			=> $am_preset_options,
				'AM_PRESET_SETTINGS'		=> $am_preset_settings,

				'U_MOVE_UP'		=> $this->u_action . '&amp;action=move_up&amp;id=' . $row['am_preset_id'],
				'U_MOVE_DOWN'	=> $this->u_action . '&amp;action=move_down&amp;id=' . $row['am_preset_id'],
				'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' . $row['am_preset_id'],
				'U_DELETE'		=> $this->u_action . '&amp;action=delete&amp;id=' . $row['am_preset_id'])
			);
		}
		$db->sql_freeresult($result);
	}
}

?>