<?php
/**
*
* @package - AM Attendance Mod
* @version $Id: functions_am.php 92 2011-01-14 16:20:42Z wired076 $
* @copyright (c) wired076 ( http://www.itconstruct.com.au/ ) 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Get user data for a specific user ID
*
* @param int $user_id ID of user
* @return array user data
*/
function am_get_user_data($user_id)
{
	global $db;

	$sql = 'SELECT *
		FROM ' . USERS_TABLE . '
		WHERE user_id = ' . (int) $user_id . '
		ORDER BY user_id';
	$result = $db->sql_query($sql);

	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row;
}

/**
* Get registration data for a specific topic
*
* @param int $topic_id ID of topic
* @return string Registered Users for this topic
*/
function am_get_registration_data($topic_id)
{
	global $db, $user;

	$sql = 'SELECT *
		FROM ' . AM_REGISTRATIONS_TABLE . '
		WHERE topic_id = ' . (int) $topic_id . '
		ORDER BY am_registration_id';
	$result = $db->sql_query($sql);

	$am_registration_data = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$am_registration_data[] = $row;
	}
	$db->sql_freeresult($result);

	$count = 0;
	$am_reguser_data = array();
	foreach($am_registration_data as $am_registration)
	{
		$cur_user_data											= am_get_user_data($am_registration['am_user_id']);
		$am_reguser_data[$count]['am_registration_id']			= $am_registration['am_registration_id'];
		$am_reguser_data[$count]['topic_id']					= $am_registration['topic_id'];
		$am_reguser_data[$count]['am_option_id']				= $am_registration['am_option_id'];
		$am_reguser_data[$count]['am_user_id']					= $am_registration['am_user_id'];
		$am_reguser_data[$count]['am_username']					= $cur_user_data['username'];
		$am_reguser_data[$count]['am_user_email']				= $cur_user_data['user_email'];
		$am_reguser_data[$count]['am_user_birthday']			= $cur_user_data['user_birthday'];
		$am_reguser_data[$count]['am_user_rank']				= $cur_user_data['user_rank'];
		$am_reguser_data[$count]['am_user_colour']				= $cur_user_data['user_colour'];
		$am_reguser_data[$count]['am_user_avatar']				= $cur_user_data['user_avatar'];
		$am_reguser_data[$count]['am_user_avatar_type']			= $cur_user_data['user_avatar_type'];
		$am_reguser_data[$count]['am_user_avatar_width']		= $cur_user_data['user_avatar_width'];
		$am_reguser_data[$count]['am_user_avatar_height']		= $cur_user_data['user_avatar_height'];
		$am_reguser_data[$count]['am_user_icq']					= $cur_user_data['user_icq'];
		$am_reguser_data[$count]['am_user_aim']					= $cur_user_data['user_aim'];
		$am_reguser_data[$count]['am_user_yim']					= $cur_user_data['user_yim'];
		$am_reguser_data[$count]['am_user_msnm']				= $cur_user_data['user_msnm'];
		$am_reguser_data[$count]['am_user_jabber']				= $cur_user_data['user_jabber'];
		$am_reguser_data[$count]['am_user_website']				= $cur_user_data['user_website'];
		$am_reguser_data[$count]['am_user_from']				= $cur_user_data['user_from'];
		$am_reguser_data[$count]['am_user_ip']					= $am_registration['am_user_ip'];
		$am_reguser_data[$count]['am_registration_time']		= $user->format_date($am_registration['am_registration_time']);
		$am_reguser_data[$count]['am_registration_confirmed']	= (($am_registration['am_registration_confirmed'] == 0) ? '' : $user->format_date($am_registration['am_registration_confirmed']));
		$count++;
	}
	unset ($cur_user_data);

	return $am_reguser_data;
}

/**
* Get options data
*
* @param int $topic_id ID of topic
* @return array option data
*/
function am_get_options($topic_id)
{
	global $db;

	// Get Options
	$sql = 'SELECT *
		FROM ' . AM_OPTIONS_TABLE . '
		WHERE topic_id = ' . (int) $topic_id . '
		ORDER BY am_option_id';
	$result = $db->sql_query($sql);

	$am_option_info = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$am_option_info[] = $row;
	}
	$db->sql_freeresult($result);

	return $am_option_info;
}

/**
* Get amount of registrations for an option
*
* @param int $option_id ID of an option
* @return array $am_option_data Registration data
*/
function am_get_registrations_per_option($am_option_id)
{
	global $db, $user;

	$sql = 'SELECT am_registration_id, am_user_id, user_colour
		FROM ' . AM_REGISTRATIONS_TABLE . ', ' . USERS_TABLE . '
		WHERE am_option_id = ' . (int) $am_option_id . '
			AND am_user_id = user_id
		ORDER BY am_registration_id';
	$result = $db->sql_query($sql);

	$am_option_reg_data = array();
	while ($row	= $db->sql_fetchrow($result))
	{
		$am_option_reg_data[]		= $row;
		//$am_option_userdata		= am_get_user_data($row['am_user_id']);
		//$am_option_reg_data[]	= $am_option_userdata['username'];
	}
	$db->sql_freeresult($result);

	$count = 0;
	$am_option_data = array();
	foreach($am_option_reg_data as $am_option)
	{
		$cur_user_data								= am_get_user_data($am_option['am_user_id']);
		$am_option_data[$count]['username']			= $cur_user_data['username'];
		$am_option_data[$count]['user_colour']		= $cur_user_data['user_colour'];
		$count++;
	}
	unset ($cur_user_data);
	return $am_option_data;
}

/**
* Get registration data for the current user
*
* @param int $topic_id ID of topic
* @return int current option id
*/
function am_get_cur_user_registration_data($topic_id)
{
	global $db, $user;

	$cur_am_option_id = 0;

	// Get current registration for the actual user
	$sql = 'SELECT am_option_id
		FROM ' . AM_REGISTRATIONS_TABLE . '
		WHERE topic_id = ' . (int) $topic_id . '
			AND am_user_id = ' . $user->data['user_id'];
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$cur_am_option_id = $row['am_option_id'];
	}
	$db->sql_freeresult($result);

	return $cur_am_option_id;
}

/**
* Get preset data
*
* @return int current option id
*/
function am_get_preset_data()
{
	global $db;

	$am_preset_ary = array();

	// Get current registration for the actual user
	$sql = 'SELECT *
		FROM ' . AM_PRESETS_TABLE;
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$am_preset_ary[]= $row;
	}
	$db->sql_freeresult($result);

	return $am_preset_ary;
}

/**
* Get username details for placing into templates.
*
* @param int $user_id The users id
* @param string $username The users name
* @param string $username_colour The users colour
* @param string $guest_username optional parameter to specify the guest username. It will be used in favor of the GUEST language variable then.
* @param string $custom_profile_url optional parameter to specify a profile url. The user id get appended to this url as &amp;u={user_id}
*
* @return string A string consisting of what is wanted based on $mode.
*/
function get_registration_username_string($user_id, $username, $username_colour = '', $guest_username = false)
{
	global $phpbb_root_path, $phpEx, $user, $auth;

	$profile_url = '';
	$username_colour = ($username_colour) ? '#' . $username_colour : '';

	if ($guest_username === false)
	{
		$username = ($username) ? $username : $user->lang['GUEST'];
	}
	else
	{
		$username = ($user_id && $user_id != ANONYMOUS) ? $username : ((!empty($guest_username)) ? $guest_username : $user->lang['GUEST']);
	}

	// Only show the link if not anonymous
	if ($user_id && $user_id != ANONYMOUS)
	{
		// Do not show the link if the user is already logged in but do not have u_viewprofile permissions (relevant for bots mostly).
		// For all others the link leads to a login page or the profile.
		if ($user->data['user_id'] != ANONYMOUS && !$auth->acl_get('u_viewprofile'))
		{
			$profile_url = '';
		}
		else
		{
			$profile_url = append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&amp;u=' . (int) $user_id);
		}
	}
	else
	{
		$profile_url = '';
	}

	$tpl = '';
	if (!$profile_url && !$username_colour)
	{
			$tpl = '{USERNAME}';
	}
	else if (!$profile_url && $username_colour)
	{
		$tpl = '<span style="color: {USERNAME_COLOUR};" >{USERNAME}</span>';
	}
	else if ($profile_url && !$username_colour)
	{
		$tpl = '<a href="{PROFILE_URL}">{USERNAME}</a>';
	}
	else if ($profile_url && $username_colour)
	{
		$tpl = '<a href="{PROFILE_URL}" style="color: {USERNAME_COLOUR};">{USERNAME}</a>';
	}

	return str_replace(array('{PROFILE_URL}', '{USERNAME_COLOUR}', '{USERNAME}'), array($profile_url, $username_colour, $username), $tpl);
}

/**
* Get registration summary
*
* @param int $topic_id ID of topic
* @return string $am_summary topic registrations list
*/
function am_get_summary($topic_id)
{
	$am_option_data		= array();
	$am_option_regusers	= array();

	$am_mouseover_list	= '';
	$am_summary_list	= '[ ';

	$am_option_data			= am_get_options($topic_id);
	$registration_data		= am_get_registration_data($topic_id);
	$am_option_data_size	= sizeof($am_option_data);

	$optioncount = 1;
	foreach ($am_option_data as $am_option)
	{
		$am_option_regusers = am_get_registrations_per_option($am_option['am_option_id']);
		$am_option_regusers_size = sizeof($am_option_regusers);
		$user_count = 1;
		
		if (!empty($am_mouseover_list))
		{
			$am_mouseover_list .= '<br /><br />';
		}
		else
		{
			$am_mouseover_list .= '<br />';
		}
		$am_mouseover_list .= '<span style="color:#'.$am_option['am_option_color'].'; font-weight:bold;">'.$am_option['am_option_text'].' - </span>';
		
		foreach ($am_option_regusers as $reguser)
		{
			$am_mouseover_list .= '<span style="color:#'.$reguser['user_colour'].';">'.$reguser['username'].'</span>';
			
			if ($user_count != $am_option_regusers_size)
			{
				$am_mouseover_list .= ', ';
			}
			$user_count++;
		}
		$am_summary_list 	.= '<span style="color:#'.$am_option['am_option_color'].'; font-weight:bold;">'.sizeof($am_option_regusers).'</span>';

		if ($optioncount == $am_option_data_size)
		{
			$am_summary_list .= ' ]';
		}
		else
		{
			$am_summary_list .= ' - ';
		}
		$optioncount++;
	}
	
	$am_summary	= '<span class="spoiler"><a href="#' . $am_option['am_option_id'] . '">'.$am_summary_list.'<span class="am_registered_users">'.$am_mouseover_list.'</span></a></span>';
	$am_mouseover_list .= '<br /><br />';
	return $am_summary;
}


/**
* Check permissions for registration
*
* @param int $topic_id ID of topic
* @return true if user is allowed to register at this topic
*/
function am_check_permissions($topic_data, $cur_am_option_id, $forum_id)
{
	global $auth;

	$s_am_permissions = array();

	if ($cur_am_option_id)
	{
		$s_am_permissions['registration_change'] = (($topic_data['am_reg_change'] == 0) ? false : true );
	}
	else
	{
		$s_am_permissions['registration_change'] = true;
	}

	// Is the user allowed to register?
	$s_am_permissions['register'] = (($auth->acl_get('f_xam_register', $forum_id)) &&
		(($topic_data['am_length'] != 0 && $topic_data['am_start'] + $topic_data['am_length'] > time()) || $topic_data['am_length'] == 0) &&
		$topic_data['topic_status'] != ITEM_LOCKED &&
		$topic_data['forum_status'] != ITEM_LOCKED) ? true : false;

	// Is the user allowed to unregister?
	$s_am_permissions['unregister'] = (($auth->acl_get('f_xam_register', $forum_id)) &&
		(($topic_data['am_length'] != 0 && $topic_data['am_start'] + $topic_data['am_length'] > time()) || $topic_data['am_length'] == 0) &&
		$topic_data['topic_status'] != ITEM_LOCKED &&
		$topic_data['forum_status'] != ITEM_LOCKED) &&
		$cur_am_option_id &&
		$topic_data['am_reg_change'] != 0 ? true : false;

	return $s_am_permissions;
}

/**
* Check if registration to option is allowed
*
* @param int $am_slots_available amount of available registration slots
* @param int $regcount count of registrations
*
* @return true if user is allowed to register at this option
*/
function am_option_registration_allowed($am_slots_available, $regcount, $topic_data, $am_option, $cur_am_option_id, $am_registration_permissions)
{
	if ($am_registration_permissions['register'] == 1)
	{
		if (empty($am_registration_permissions['registration_change']))
		{
			if (($topic_data['am_confirmable'] == 1) && ($am_option['am_option_id'] == $cur_am_option_id))
			{
				$s_am_option_can_register = true;
			}
			else
			{
				$s_am_option_can_register = false;
			}
		}
		else if ($am_slots_available == 0 && $regcount > 0)
		{
			if (($topic_data['am_confirmable'] == 1) && ($am_option['am_option_id'] == $cur_am_option_id))
			{
				$s_am_option_can_register = true;
			}
			else
			{
				$s_am_option_can_register = false;
			}
		}
		else if (($topic_data['am_confirmable'] == 0) && ($am_option['am_option_id'] == $cur_am_option_id))
		{
			$s_am_option_can_register = false;
		}
		else
		{
			$s_am_option_can_register = true;
		}
	}
	else
	{
		$s_am_option_can_register = false;
	}

	return $s_am_option_can_register;
}


function am_registration_display($s_am_layout, $am_option_info, $am_registration_data, $topic_data, $cur_am_option_id, $am_registration_permissions, $viewtopic_url)
{
    global $config, $auth, $user, $template;

    $template->set_filenames(array(
        'am_body'        => $s_am_layout)
    );

	$am_user_div = array();

	$optioncount = 0;
	foreach ($am_option_info as $am_option)
	{
		$cur_registrations 			= '';
		$cur_registration_times 	= '';
		$cur_confirmation_times		= '';

		$regcount = 0;
		$i = 0;
		foreach($am_registration_data as $am_registration)
		{
			$reg_delimiter = (!empty($cur_registrations) ? '<br />' : '');
			if ($am_registration['am_option_id'] == $am_option['am_option_id'])
			{
				$am_user_div[$i]['id']				= $am_registration['am_user_id'];
				$am_user_div[$i]['username']		= $am_registration['am_username'];
				$am_user_div[$i]['email']			= $am_registration['am_user_email'];
				$am_user_div[$i]['colour']			= $am_registration['am_user_colour'];
				$am_user_div[$i]['avatar']			= get_user_avatar($am_registration['am_user_avatar'], $am_registration['am_user_avatar_type'], $am_registration['am_user_avatar_width'], $am_registration['am_user_avatar_height'], $am_registration['am_username']);
				$am_user_div[$i]['avatar_width']	= $am_registration['am_user_avatar_width'];
				$am_user_div[$i]['ip']				= $am_registration['am_user_ip'];
				$am_user_div[$i]['regtime']			= $am_registration['am_registration_time'];
				$am_user_div[$i]['conftime']		= (empty($am_registration['am_registration_confirmed']) ? '' : $am_registration['am_registration_confirmed']);

				$cur_username			= get_registration_username_string($am_registration['am_user_id'], $am_registration['am_username'], $am_registration['am_user_colour']);
				$cur_registrations		= $cur_registrations.$reg_delimiter.$cur_username;
				$cur_registration_times	= $cur_registration_times.$reg_delimiter.$am_registration['am_registration_time'];
				$cur_confirmation_times	= $cur_confirmation_times.$reg_delimiter.$am_registration['am_registration_confirmed'];
				$regcount++;
			}
			$i++;
		}

		$s_am_option_tablerow_change = (($optioncount % 2 === 1) ? true : false);

		$am_slots_available = $am_option['am_option_max'] - $regcount;
		$s_am_option_can_register = am_option_registration_allowed($am_slots_available, $regcount, $topic_data, $am_option, $cur_am_option_id, $am_registration_permissions);
		$s_can_am_confirm = (($topic_data['am_confirmable'] == 1) ? true : false );

		if (!empty($regcount) && $regcount > 1)
		{
			$cur_num_registrations = sprintf($user->lang['AM_NUM_REGISTRATIONS'], $regcount);
		}
		else if ($regcount == 1)
		{
			$cur_num_registrations = sprintf($user->lang['AM_NUM_REGISTRATION'], $regcount);
		}
		else
		{
			$cur_num_registrations = $user->lang['AM_NUM_NO_REGISTRATION'];
		}

		$template->assign_block_vars('am_option', array(
			'AM_OPTION_ID' 					=> $am_option['am_option_id'],
			'AM_OPTION_TEXT' 				=> $am_option['am_option_text'],
			'AM_OPTION_MAX' 				=> (!empty($am_option['am_option_max']) ? sprintf($user->lang['AM_SLOTS_AVAILABLE'], $am_slots_available, $am_option['am_option_max']) : ''),
			'AM_OPTION_COLOR' 				=> '#'.$am_option['am_option_color'],
			'AM_OPTION_REGISTERED'			=> ($am_option['am_option_id'] == $cur_am_option_id) ? true : false,
			'AM_OPTION_REGISTRATIONS'		=> $cur_registrations,
			'AM_OPTION_REGISTRATION_TIMES'	=> $cur_registration_times,
			'AM_OPTION_CONFIRMATION_TIMES'	=> $cur_confirmation_times,
			'AM_OPTION_NUM_REGISTRATIONS'	=> $cur_num_registrations,

			'S_AM_OPTION_TABLEROW_CHANGE'	=> $s_am_option_tablerow_change,
			'S_AM_OPTION_CAN_REGISTER'		=> $s_am_option_can_register)
		);

		unset($cur_username, $cur_registrations, $cur_registration_times, $cur_confirmation_times, $cur_num_registrations);
		$optioncount++;
	}

	foreach ($am_user_div as $am_div)
	{
		$template->assign_block_vars('am_user_div', array(
			'AM_DIV_USER_ID' 		=> $am_div['id'],
			'AM_DIV_AVATAR' 		=> $am_div['avatar'],
			'AM_DIV_USERNAME' 		=> $am_div['username'],
			'AM_DIV_EMAIL' 			=> $am_div['email'],
			'AM_DIV_IP' 			=> $am_div['ip'],
			'AM_DIV_COLOUR'			=> $am_div['colour'],
			'AM_DIV_REGISTRATION'	=> $am_div['regtime'],
			'AM_DIV_CONFIRMATION'	=> $am_div['conftime'],

			'S_HAS_AVATAR'			=> (($am_div['avatar_width'] > 0) ? true : false),
			'S_IS_ADMIN'			=> (($auth->acl_get('a_') && $user->data['is_registered']) ? true : false)
			)
		);
	}

	$am_end	= $topic_data['am_length'] + $topic_data['am_start'];

	$template->assign_vars(array(
		'L_AM_LENGTH'			=> ($topic_data['am_length']) ? sprintf($user->lang[($am_end > time()) ? 'AM_REGISTRATION_TILL' : 'AM_REGISTRATION_ENDED_AT'], $user->format_date($am_end)) : '',

		'S_HAS_AM_REGISTRATION'	=> (count($am_option_info) ? true : false),
		'S_CAN_AM_UNREGISTER'	=> $am_registration_permissions['unregister'],
		'S_CAN_AM_CONFIRM'		=> $s_can_am_confirm,
		'S_AM_ACTION'			=> $viewtopic_url)
	);

	unset($am_user_div);

    // Return templated data
    return $template->assign_display('am_body');
}

function am_registration_preview($s_am_layout, $post_data)
{
    global $config, $auth, $user, $template;

    $template->set_filenames(array(
        'am_body'        => $s_am_layout)
    );

	$am_end	= ($post_data['am_length'] * 86400) + time();

	$key = 0;
	for ($key = 0; $key < sizeof($post_data['am_options']); $key++)
	{
		$s_am_option_tablerow_change = (($key % 2 === 1) ? true : false);

		$template->assign_block_vars('am_option', array(
			'AM_OPTION_TEXT' 				=> $post_data['am_options'][$key],
			'AM_OPTION_MAX' 				=> (!empty($post_data['am_options_max'][$key]) ? sprintf($user->lang['AM_SLOTS_AVAILABLE'], $post_data['am_options_max'][$key], $post_data['am_options_max'][$key]) : ''),
			'AM_OPTION_COLOR' 				=> $post_data['am_options_color'][$key],

			'S_AM_OPTION_TABLEROW_CHANGE'	=> $s_am_option_tablerow_change)
		);
	}

	$template->assign_vars(array(
		'L_AM_LENGTH'			=> ($post_data['am_length']) ? sprintf($user->lang[($am_end > time()) ? 'AM_REGISTRATION_TILL' : 'AM_REGISTRATION_ENDED_AT'], $user->format_date($am_end)) : '',

		'S_HAS_AM_REGISTRATION'	=> (sizeof($post_data['am_options'])),
		'S_CAN_AM_CONFIRM'		=> $post_data['am_confirmable'])
	);

    // Return templated data
    return $template->assign_display('am_body');
}
?>