<?php

/**
*
* @package - AM Attendance Mod
* @version $Id: index.php 92 2011-01-14 16:20:42Z wired076 $
* @copyright (c) wired076 ( http://www.itconstruct.com.au/ ) 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'install/am_install_functions.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->add_lang('acp/common');
$new_mod_version = '0.2.0';
$page_title = 'Attendance Mod, Version' . $new_mod_version;

$am_module_array = array();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
   trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}
$mod_name = 'TITLE';
$version_config_name = 'am_mod_version';
$language_file = 'mods/info_am_presets';

$versions = array(
   // Version 0.2.9
   '0.2.9'   => array(
	 'config_add' => array(
	   array('am_number', 5),
	   array('am_page_number', 0),
	   array('am_anti_topics', 0),
	   array('am_index', 1),
	 ),
	 'module_add' => array(
	   array('acp', 'ACP_CAT_DOT_MODS', 'ATTENDANCE MOD'),

	   array('acp', 'ATTENDANCE MOD', array(
			'module_basename'	=> 'am_presets',
			'module_enabled'	=> 1,
			'module_display'	=> 1,
			'parent_id'         => 'module_id',
			'module_class'      => 'acp',
			'module_langname'   => 'ACP_AM_PRESETS',
			'module_mode'		=> 'presets',
			'module_auth'		=> ''
		),
	   ),
	 ),
	 'table_add' => array(
	   array('phpbb_am_options', array(
		 'COLUMNS' => array(
			'am_option_id'		=> array('UINT', NULL, 'auto_increment'),
			'topic_id'			=> array('UINT', 0),
			'am_option_text'	=> array('TEXT', ''),
			'am_option_max'		=> array('BOOL', '0'),
			'am_option_color'	=> array('VCHAR:6', '000000'),
		 ),

		 'PRIMARY_KEY'	=> 'am_option_id',

		 'KEYS'	=> array(
			'am_topic_id'	=> array('INDEX', array('topic_id')),
			),
	   )),

	   array('phpbb_am_registrations', array(
		 'COLUMNS'	=> array(
			'am_registration_id'		=> array('UINT', NULL, 'auto_increment'),
			'topic_id'					=> array('UINT', 0),
			'am_option_id'				=> array('UINT', 0),
			'am_user_id'				=> array('UINT', 0),
			'am_user_ip'				=> array('VCHAR:40', '0'),
			'am_registration_time'		=> array('INT:11', 0),
			'am_registration_confirmed'	=> array('INT:11', 0),
		 ),

		 'PRIMARY_KEY'	=> 'am_registration_id',

		 'KEYS'	=> array(
			'am_option_id'	=> array('INDEX', array('am_option_id', 'am_user_id', 'topic_id')),
		 ),
	   )),

	   array('phpbb_am_presets', array(
		 'COLUMNS'	=> array(
			'am_preset_id'		=> array('UINT', NULL, 'auto_increment'),
			'am_preset_name'	=> array('VCHAR:50', '0'),
			'am_length'			=> array('INT:11', 0),
			'am_visible'		=> array('TINT:1', 0),
			'am_confirmable' 	=> array('TINT:1', 0),
			'am_reg_change' 	=> array('TINT:1', 0),
			'am_layout' 		=> array('TINT:2', 0),
			'am_option_text' 	=> array('TEXT', ''),
			'am_option_max' 	=> array('TEXT', ''),
			'am_option_color'	=> array('TEXT', ''),
			'am_preset_order'	=> array('UINT', 0),
		 ),

		 'PRIMARY_KEY'	=> 'am_preset_id',
	   )),

	 ),
	 
	 'table_column_add'	=> array(
	   array('phpbb_topics', 'am_start', array('INT:11', 0)),
	   array('phpbb_topics', 'am_length', array('INT:11', 0)),
	   array('phpbb_topics', 'am_visible', array('TINT:1', 0)),
	   array('phpbb_topics', 'am_confirmable', array('TINT:1', 0)),
	   array('phpbb_topics', 'am_reg_change', array('TINT:1', 0)),
	   array('phpbb_topics', 'am_layout', array('TINT:2', 0)),
	 ),
	 'permission_add' => array(
	   'am_permissions',
	   array('f_xam_register', false),
	   array('f_xam_create', false),
	   array('f_xam_preset', false),
		 ),
	),
	// Version 0.2.10
	'0.2.10' => array(),
	// Version 0.3.1
	'0.3.1'	=> array(),
	// Version 0.3.2
	'0.3.2'	=> array(),
	// Version 1.0.0
	'1.0.0'	=> array(),
	// Version 1.0.1
	'1.0.1'	=> array(),
	// Version 1.0.2
	'1.0.2'	=> array(),
	//Version 1.0.3
	'1.0.3' => array(),
	);
	
// Include the UMIL Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);
$cache->purge();
?>